(function (root) {
  var exports = undefined,
      module = undefined,
      require = undefined;
  var define = undefined;
  var self = root,
      window = root,
      global = root,
      globalThis = root;
  (function () {
    (() => {
      var s = {
        671: (t, e, s) => {
          let i = s(174);

          function n(t, e) {
            return e.prior - t.prior;
          }

          window.bccore.GAssetMgr = new class {
            constructor() {
              this._onReqs = {}, this._waitReqs = [], this._reqCache = [], this._maxReqCache = 200, this._aCache = {}, this._tickKey = 0, this._frameLoadMax = 200, this._loadCount = 0, this._allLoadMax = 200;
              let t = cc.assetManager.downloader;
              t.maxConcurrency = 200, t.maxRequestsPerFrame = 200, this._loadIds = new i(), window.bccore.GTimeMgr.exeTime(this.cacheTime.bind(this), 1e3, -1);
            }

            loadAsset(t, e, s, i, r, a) {
              void 0 === a ? a = 5e3 : a < 0 && (a = 0);
              var o = this._loadIds.useId;
              let n = this.newWaitRequest();
              return n.bundle = t, n.path = e, n.useId = o, n.aType = s, n.bTime = a, n.prior = i, n.func = r, this._waitReqs.push(n), 0 == this._tickKey && (this._tickKey = window.bccore.GTimeMgr.exeFrame(this.loadTick.bind(this), 99999)), o;
            }

            preloadAs(t, e, s, i) {
              let r = cc.assetManager.getBundle(t);

              if (r) {
                let t;

                switch (s) {
                  case 0:
                    t = cc.Texture2D;
                    break;

                  case 1:
                    t = cc.ImageAsset;
                    break;

                  case 2:
                    t = cc.SpriteFrame;
                    break;

                  case 3:
                    t = cc.Prefab;
                    break;

                  case 4:
                    t = cc.JsonAsset;
                    break;

                  case 5:
                    t = cc.SpriteAtlas;
                    break;

                  case 6:
                    t = cc.internal.SpineSkeletonData;
                    break;

                  case 7:
                    t = cc.EffectAsset;
                    break;

                  case 8:
                    t = cc.Font;
                    break;

                  case 9:
                    t = cc.BitmapFont;
                    break;

                  case 10:
                    t = cc.Material;
                    break;

                  case 11:
                    t = cc.BufferAsset;
                    break;

                  case 12:
                    t = cc.AudioClip;
                }

                r.preload(e, t, this.endPreLoad.bind(this, i));
              }
            }

            endPreLoad(t, e, s) {
              e ? globalThis.prinf(e) : t && t();
            }

            remLoad(s) {
              if (!(s <= 0)) {
                let t = this._onReqs;
                var i = t[s];
                if (i) return delete t[s], void this.waitRequestBin(i);
                let e = this._waitReqs;

                for (let t = 0; t < e.length; t++) {
                  var r = e[t];

                  if (s == r.useId) {
                    e.splice(t, 1), this.waitRequestBin(r);
                    break;
                  }
                }
              }
            }

            getCache(t, e) {
              let s = void 0;
              t = this._aCache[t + "/" + e];
              return s = t ? t.res : s;
            }

            newWaitRequest() {
              let t,
                  e = this._reqCache;
              return t = 0 < e.length ? e.pop() : {};
            }

            waitRequestBin(e) {
              if (e) {
                e.bundle = "", e.useId = 0, e.path = "", e.bTime = 0, e.aType = 0, e.func = void 0;
                let t = this._reqCache;
                t.length < this._maxReqCache && t.push(e);
              }
            }

            loadTick() {
              for (;;) {
                let t = this._loadCount;
                var i = this._allLoadMax;
                if (t >= i) break;
                let e = this._waitReqs;
                if (0 == e.length) break;
                e.sort(n);
                let s = i - t;

                for (s > this._frameLoadMax && (s = this._frameLoadMax); 0 < s;) {
                  var r = e.pop();
                  if (!r) break;
                  var a = this.getCache(r.bundle, r.path);

                  if (a) {
                    let t = r.func;
                    var o = r.useId;
                    if (this.waitRequestBin(r), t) try {
                      t(a, o);
                    } catch (t) {
                      globalThis.errLog(t, "asset-useCache");
                    }
                  } else this.exeLoad(r) ? (t++, s--) : this.waitRequestBin(r);
                }

                this._loadCount = t;
              }
            }

            cacheTime() {
              for (var s in this._aCache) {
                let e = this._aCache[s];

                if (e) {
                  let t = e.res;
                  1 == t.refCount && (e.bTime = e.bTime - 1e3, e.bTime <= 0 && (t.decRef(), e.res = null, delete this._aCache[s]));
                }
              }
            }

            exeLoad(e) {
              let s = !0;
              var i = e.bundle;
              let r = cc.assetManager.getBundle(i);

              if (r) {
                let t;

                switch (e.aType) {
                  case 0:
                    t = cc.Texture2D;
                    break;

                  case 1:
                    t = cc.ImageAsset;
                    break;

                  case 2:
                    t = cc.SpriteFrame;
                    break;

                  case 3:
                    t = cc.Prefab;
                    break;

                  case 4:
                    t = cc.JsonAsset;
                    break;

                  case 5:
                    t = cc.SpriteAtlas;
                    break;

                  case 6:
                    t = cc.internal.SpineSkeletonData;
                    break;

                  case 7:
                    t = cc.EffectAsset;
                    break;

                  case 8:
                    t = cc.Font;
                    break;

                  case 9:
                    t = cc.BitmapFont;
                    break;

                  case 10:
                    t = cc.Material;
                    break;

                  case 11:
                    t = cc.BufferAsset;
                    break;

                  case 12:
                    t = cc.AudioClip;
                }

                t ? (i = e.useId, this._onReqs[i] = e, r.load(e.path, t, this.endLoad.bind(this, i))) : s = !1;
              } else s = !1;

              return s;
            }

            endLoad(e, t, s) {
              this._loadCount--;
              var i = this._onReqs[e];

              if (i) {
                delete this._onReqs[e], s && this.setCache(s, i);
                let t = i.func;
                if (this.waitRequestBin(i), t) try {
                  t(s, e);
                } catch (t) {
                  globalThis.errLog(t, "asset-endLoad");
                }
              } else s && cc.assetManager.releaseManager.tryRelease(s);
            }

            setCache(t, e) {
              let s = this._aCache;
              globalThis.isDebug && (globalThis.cache = this._aCache);
              var i = e.bundle + "/" + e.path;
              let r = s[i];

              if (r) {
                let t = r.res;
                t && t.decRef();
              } else r = {};

              t.addRef(), r.res = t, r.bTime = e.bTime, r.wTime = -1, s[i] = r;
            }

          }();
        },
        746: function (t) {
          var e = this && this.__decorate || function (t, e, s, i) {
            var r,
                a = arguments.length,
                o = a < 3 ? e : null === i ? i = Object.getOwnPropertyDescriptor(e, s) : i;
            if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) o = Reflect.decorate(t, e, s, i);else for (var n = t.length - 1; 0 <= n; n--) (r = t[n]) && (o = (a < 3 ? r(o) : 3 < a ? r(e, s, o) : r(e, s)) || o);
            return 3 < a && o && Object.defineProperty(e, s, o), o;
          };

          let s = class extends cc.Sprite {
            constructor() {
              super(...arguments), this._loadInfo = null, this._frames = [], this._isRun = !1, this._rate = 12, this._curRunIdx = 0, this._isLoop = !1, this._plistPath = "", this._isStop = !1;
            }

            reset() {
              this.sizeMode = 2, this.trim = !1, this._frameMgr = window.SpFrameMgr;
            }

            loadAni(t, e, s, i = 0, r = 0, a = 0, o = 0) {
              t && e && (this.reset(), i < 0 && (i = 0), r < 0 && (r = 0), this._loadInfo || (this._loadInfo = {
                startIdx: i,
                endIdx: r,
                namePre: s
              }), r = this._frameMgr.getAtlasCount(i = t + "/" + (e + ".plist")), this._plistPath = i, r ? this.initFrames(r) : this._loadKey = window.bccore.GAssetMgr.loadAsset(t, e, 5, a, this.recvLoad.bind(this), o));
            }

            recvLoad(t) {
              var e;
              this._loadKey = 0, t && (e = this._plistPath, (e = this._frameMgr.addPlist(e, t)) && (this._isRun = !0, this.initFrames(e)));
            }

            addFrame(t) {
              t && (this._frames.push(t), t.addRef());
            }

            initFrames(t) {
              this.decFrames();
              var s = this._loadInfo;

              if (s) {
                var i = s.startIdx;
                let e = this._loadInfo.endIdx;
                0 === e && (e = this._loadInfo.endIdx = t - 1);

                for (let t = i; t <= e; t++) {
                  var r = s.namePre + t,
                      r = this._frameMgr.getSpFrame(r);

                  r && this.addFrame(r);
                }
              }

              this._isRun && this.run();
            }

            run() {
              this._frames.length && (this._runTime = Math.floor(this.playFramesCount / this._rate * 1e3), this.runIdx = this._loadInfo.startIdx, this._curTime = Date.now(), this._passTime = 0, this._isRun = !0);
            }

            update(t) {
              if (this._isRun) {
                var e = Date.now(),
                    s = e - this._curTime;
                this._curTime = e;
                let t = this._passTime + s;
                e = this._runTime;

                if (t >= e) {
                  if (!this._isLoop) {
                    let t = this._runEndCb;
                    return t && t(), void (this._isRun = !1);
                  }

                  t -= e;
                }

                this.runIdx = Math.floor(t / e * this.playFramesCount), this._passTime = t;
              }
            }

            set runEndCall(t) {
              this._runEndCb = t;
            }

            set runIdx(t) {
              var e;
              t != this._curRunIdx && (e = this._frames, t > this._loadInfo.endIdx || (this.spriteFrame = e[t], this._curRunIdx = t));
            }

            set rate(t) {
              this._rate = t;
            }

            get playFramesCount() {
              return this._loadInfo.endIdx - this._loadInfo.startIdx + 1;
            }

            set isLoop(t) {
              this._isLoop = t;
            }

            setPlayIdx(t, e, s) {
              !this._isRun || 0 == t || 0 == e || e < t || (this._loadInfo.startIdx = t, this._loadInfo.endIdx = e, s && (this._loadInfo.namePre = s), this.initFrames());
            }

            decFrames() {
              let e = this._frames;

              for (; e.length;) {
                let t = e.pop();
                t.decRef();
              }

              this._frames = [];
            }

            set isRun(t) {
              this._isRun = t;
            }

            _onPreDestroy() {
              this.decFrames(), this._loadKey && (window.bccore.GAssetMgr.remLoad(this._loadKey), this._loadKey = 0), this._plistPath && (this._frameMgr.tryCleanPlist(this._plistPath), this._plistPath = "");
              this._frameMgr = null, this._loadInfo = null, this._runEndCb = null, this._isRun = !1, this._curRunIdx = 0, super._onPreDestroy();
            }

          };
          s = e([cc._decorator.ccclass("AniCpn")], s);
          e = window.bccore.AniCpn = s;
          t.exports = e;
        },
        47: function (t) {
          var e = this && this.__decorate || function (t, e, s, i) {
            var r,
                a = arguments.length,
                o = a < 3 ? e : null === i ? i = Object.getOwnPropertyDescriptor(e, s) : i;
            if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) o = Reflect.decorate(t, e, s, i);else for (var n = t.length - 1; 0 <= n; n--) (r = t[n]) && (o = (a < 3 ? r(o) : 3 < a ? r(e, s, o) : r(e, s)) || o);
            return 3 < a && o && Object.defineProperty(e, s, o), o;
          },
              s = this && this.__metadata || function (t, e) {
            if ("object" == typeof Reflect && "function" == typeof Reflect.metadata) return Reflect.metadata(t, e);
          };

          let i = class extends cc.ButtonComponent {
            constructor() {
              super(), this.transition = 2;
            }

            set norFrame(t) {
              let e = this._norFrame;
              e && e.decRef(), t && t.addRef(), this._norFrame = t, this.normalSprite = t;
            }

            set preFrame(e) {
              if (2 === this.transition) {
                let t = this._preFrame;
                t && t.decRef(), e && e.addRef(), this._preFrame = e, this.pressedSprite = e;
              }
            }

            set hovFrame(e) {
              if (2 === this.transition) {
                let t = this._hovFrame;
                t && t.decRef(), e && e.addRef(), this._hovFrame = e, this.hoverSprite = e;
              }
            }

            set disFrame(e) {
              if (2 === this.transition) {
                let t = this._disFrame;
                t && t.decRef(), e && e.addRef(), this._disFrame = e, this.disabledSprite = e;
              }
            }

            _onPreDestroy() {
              let t = this._norFrame,
                  e = (t && (t.decRef(), this._norFrame = void 0), this.normalSprite = null, this._preFrame),
                  s = (e && (e.decRef(), this._preFrame = void 0), this.pressedSprite = null, this._hovFrame),
                  i = (s && (s.decRef(), this._hovFrame = void 0), this.hoverSprite = null, this._disFrame);
              i && (i.decRef(), this._disFrame = void 0), this.disabledSprite = null, super._onPreDestroy();
            }

          };
          i = e([cc._decorator.ccclass("BtnCpn"), s("design:paramtypes", [])], i);
          e = window.bccore.BtnCpn = i;
          t.exports = e;
        },
        616: function (t) {
          var e = this && this.__decorate || function (t, e, s, i) {
            var r,
                a = arguments.length,
                o = a < 3 ? e : null === i ? i = Object.getOwnPropertyDescriptor(e, s) : i;
            if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) o = Reflect.decorate(t, e, s, i);else for (var n = t.length - 1; 0 <= n; n--) (r = t[n]) && (o = (a < 3 ? r(o) : 3 < a ? r(e, s, o) : r(e, s)) || o);
            return 3 < a && o && Object.defineProperty(e, s, o), o;
          },
              s = this && this.__metadata || function (t, e) {
            if ("object" == typeof Reflect && "function" == typeof Reflect.metadata) return Reflect.metadata(t, e);
          };

          let i = class extends cc.LabelComponent {
            constructor() {
              super(), this._loadKey = 0, this.overflow = 1;
            }

            set useFont(t) {
              t != this._curFont && (this.fontBin(), this.useSystemFont = !1, (this.font = t) && t.addRef(), this._curFont = t);
            }

            setFontName(t, e, s, i = 0, r) {
              let a = window.bccore.GAssetMgr;
              var o = this._loadKey;
              o && a.remLoad(o), this.fontBin(), this._loadKey = a.loadAsset(t, e, s, i, this.recvFont.bind(this), r);
            }

            set useSystem(t) {
              t && (this.font = null, this.fontBin()), this.useSystemFont = t;
            }

            set loadedFunc(t) {
              this._loadedFunc = t;
            }

            clear() {
              this.fontBin();
            }

            _onPreDestroy() {
              this.fontBin(), this._loadedFunc = void 0, super._onPreDestroy();
            }

            fontBin() {
              var t = this._loadKey;
              t && (window.bccore.GAssetMgr.remLoad(t), this._loadKey = 0);
              let e = this._curFont;
              e && (e.decRef(), this._curFont = void 0);
            }

            recvFont(t) {
              this._loadKey = 0, this.useFont = t;
              let e = this._loadedFunc;
              e && e();
            }

            set outlineWidth(t) {
              let e = this._outlineCom;
              e || (e = this.node.addComponent(cc.LabelOutlineComponent), this._outlineCom = e), e.width = t;
            }

            set outlineColor(t) {
              let e = this._outlineCom;
              e || (e = this.node.addComponent(cc.LabelOutlineComponent), this._outlineCom = e), e.color = new cc.Color(t);
            }

          };
          i = e([cc._decorator.ccclass("LabelCpn"), s("design:paramtypes", [])], i);
          e = window.bccore.LabelCpn = i;
          t.exports = e;
        },
        131: t => {
          class e extends cc.AudioSourceComponent {
            constructor() {
              super(), this._shortLoads = {}, this._spShortLoads = {};
            }

            init(t, e, s = 0, i, r, a) {
              var o;
              !this.isValid || (o = t + "/" + e) != this._dynPath && (this.clear(), 0 < (t = window.bccore.GAssetMgr.loadAsset(t, e, 12, s, this.recvLoad.bind(this), i)) && (this._dynPath = o, this._loadId = t), this._muteTypeDic = a, this._soundVol = r);
            }

            initShort(t, e, s = 0, i, r) {
              this.isValid && t + "/" + e != this._dynPath && 0 < (t = window.bccore.GAssetMgr.loadAsset(t, e, 12, s, this.recvShortLoad.bind(this, r), i)) && (this._shortLoads[t] = 1);
            }

            initSpShort(t, e, s = 0, i) {
              this.isValid && t + "/" + e != this._dynPath && 0 < (t = window.bccore.GAssetMgr.loadAsset(t, e, 12, s, this.recvSpShortLoad.bind(this), i)) && (this._spShortLoads[t] = 1);
            }

            recvLoad(t) {
              this._loadId = 0;
              let e = !1;
              t ? (t.addRef(), this.clip && (this.onStop(), this.clip.decRef()), this.clip = t, 1 == this.mState && this.onPlay(), e = !0) : this._dynPath = "", this._loadCb && this._loadCb(e);
            }

            recvShortLoad(e, s, t) {
              if (delete this._shortLoads[t], s) {
                let t = this;

                function i() {
                  t.playOneShot(s);
                }

                e ? window.bccore.GTimeMgr.exeTime(i.bind(this), e, 1) : i();
              }
            }

            recvSpShortLoad(t, e) {
              delete this._spShortLoads[e], this.playing && this.clip == t || t && this.playOneShot(t);
            }

            onPlay() {
              this.clip && !this.playing && this.play(), this._mState = 1;
            }

            onPause() {
              this.clip && this.pause(), this._mState = 2;
            }

            onStop() {
              this.clip && this.stop(), this._mState = 3;
            }

            set isPlayOnAwake(t) {
              this.playOnAwake = t;
            }

            set mState(t) {
              this._mState = t;
            }

            get mState() {
              return this._mState;
            }

            set type(t) {
              0 <= t && (this._type = t);
            }

            get type() {
              return this._type;
            }

            set playEndCb(t) {
              this._endCb = t;
            }

            set vol(t) {
              this.volume = t;
            }

            get vol() {
              return this.volume;
            }

            set isLoop(t) {
              this.loop = t;
            }

            set loadEndCb(t) {
              this._loadCb = t;
            }

            clear() {
              let t = this.clip;
              t && (this.stop(), this.clip = null, t.decRef(), this.clip = void 0);
              var e = this._loadId;
              0 < e && (window.bccore.GAssetMgr.remLoad(e), this._loadId = 0), this._dynPath = "", this._mState = 0;
            }

            reset() {
              this._loadCb = null, this._endCb = null, this.playEndCb = null, this._muteTypeDic = null;
            }

            _onPreDestroy() {
              let t = this._shortLoads;

              for (var e in t) {
                e = parseInt(e);
                delete t[e], 0 < e && window.bccore.GAssetMgr.remLoad(e);
              }

              let s = this._spShortLoads;

              for (var i in s) {
                i = parseInt(i);
                delete s[i], 0 < i && window.bccore.GAssetMgr.remLoad(i);
              }

              this.clear(), super._onPreDestroy();
            }

          }

          window.bccore.MusicCpn = e, t.exports = e;
        },
        523: function (t) {
          var e = this && this.__decorate || function (t, e, s, i) {
            var r,
                a = arguments.length,
                o = a < 3 ? e : null === i ? i = Object.getOwnPropertyDescriptor(e, s) : i;
            if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) o = Reflect.decorate(t, e, s, i);else for (var n = t.length - 1; 0 <= n; n--) (r = t[n]) && (o = (a < 3 ? r(o) : 3 < a ? r(e, s, o) : r(e, s)) || o);
            return 3 < a && o && Object.defineProperty(e, s, o), o;
          },
              s = this && this.__metadata || function (t, e) {
            if ("object" == typeof Reflect && "function" == typeof Reflect.metadata) return Reflect.metadata(t, e);
          };

          let i = class extends cc.internal.SpineSkeleton {
            constructor() {
              super(), this._loadId = 0, this._dynPath = "", this._useData = null, this._checkPlayId = 0, this._alpha = 255, this._speedRate = 1, this._maxEndTime = 300, this._aniInfo = {
                name: "",
                loop: !1,
                bTime: 0,
                eTime: -1,
                path: "",
                bundle: ""
              };
            }

            loadSpine(t, e, s = 0, i, r) {
              var a;
              !this.isValid || (a = t + "/" + e) != this._dynPath && (this.clear(), this._aniInfo.path = e, this._aniInfo.bundle = t, this._skinName = r, 0 < (r = window.bccore.GAssetMgr.loadAsset(t, e, 6, s, this.recvLoad.bind(this), i)) && (this._dynPath = a, this._loadId = r));
            }

            play(s, i = !1, r = 0, a = -1) {
              if (s && "" !== s) {
                let t = this._aniInfo,
                    e = (t.name = s, t.loop = i, t.bTime = r, t.eTime = a, window.bccore.GTimeMgr);

                if (this._chkHaveAs && (this._timestamp = Date.now()), this._isOnLoadCalled && this._useData) {
                  let t = this.setAnimation(0, s, i);
                  t && (t.animationStart = r, 0 <= a && (t.animationEnd = a));
                  s = this._checkPlayId;
                  0 < s && (e.remFrame(s), this._checkPlayId = 0), this.node.skipRender = !1;
                } else 0 == this._checkPlayId && (this._checkPlayId = e.exeFrame(this.checkPlay.bind(this)));
              }
            }

            freeze(t, e) {
              let s = this.setAnimation(0, t, !1);
              s && (s.animationStart = e, s.animationEnd = e);
            }

            setCacheMode(t) {
              super.setAnimationCacheMode(t);
            }

            set loadedFunc(t) {
              this._loadedFunc = t;
            }

            get isExistData() {
              let t = !1;
              return t = this._useData ? !0 : t;
            }

            set playEndCall(t) {
              this.setCompleteListener(t);
            }

            set alpha(t) {
              let e = this._useColor;
              e || (e = this.color.clone(), this._useColor = e), e.a != t && (e.a = t), this._alpha = t, this.color = e;
            }

            set spColor(t) {
              this.color = t, this._useColor = t;
            }

            getSpLocalPos(e) {
              let s = new cc.Vec3();
              if ("" != e && this._skeletonData) if (this._isOnLoadCalled) try {
                var t = this.findBone(e);
                t && (s.x = Math.ceil(t.x), s.y = Math.ceil(t.y));
              } catch (t) {
                e = this.findBone("root");
                e && (s.x = Math.ceil(e.x), s.y = Math.ceil(e.y));
              }
              return s;
            }

            getSpWorldPos(e) {
              let s = new cc.Vec3();
              if ("" != e && this._skeletonData) if (this._isOnLoadCalled) try {
                var t = this.findBone(e);
                t && (s.x = Math.ceil(t.worldX), s.y = Math.ceil(t.y));
              } catch (t) {
                e = this.findBone("root");
                e && (s.x = Math.ceil(e.worldX), s.y = Math.ceil(e.worldX));
              }
              return s;
            }

            _onPreDestroy() {
              this.clear();
              this._loadedFunc = void 0, this._aniInfo = void 0, super._onPreDestroy();
            }

            clear() {
              var t = this._loadId;
              0 < t && (window.bccore.GAssetMgr.remLoad(t), this._loadId = 0), this._dynPath = "";
              let e = this._useData;
              e && (e.decRef(), this._state = null, e = null, this._useData = null, this.skeletonData = null, this._skeleton = null);
              t = this._checkPlayId;
              0 < t && (window.bccore.GTimeMgr.remFrame(t), this._checkPlayId = 0);
              let s = this.sockets;

              if (s) {
                for (; 0 < s.length;) {
                  let t = s.pop();
                  t && (t.target = null);
                }

                this.sockets = s;
              }

              this.node.skipRender = !1;
              let i = this._aniInfo;
              i.name = "", i.loop = !1, i.bTime = 0, i.eTime = -1, i.path = "", i.bundle = "", this._timestamp = 0;
            }

            recvLoad(t) {
              let e = !(this._loadId = 0),
                  s = (t ? (t.addRef(), this._useData = t, this.skeletonData = t, this.timeScale = this._speedRate, this.updateSocketCaches()) : (this._dynPath = "", e = !1), this._useColor && (this.color = this._useColor), this.alpha = this._alpha, this._loadedFunc);
              s && s(e);
            }

            set chkHaveAs(t) {
              this._chkHaveAs = t;
            }

            checkPlay() {
              if (this._isOnLoadCalled && this._useData) {
                var e,
                    s = this._aniInfo;
                if (this._timestamp) if (Date.now() - this._timestamp >= this.maxEndTime) return void (0 < (e = this._checkPlayId) && (window.bccore.GTimeMgr.remFrame(e), this._checkPlayId = 0));
                let t = this.setAnimation(0, s.name, s.loop);
                t && (t.animationStart = s.bTime, 0 <= s.eTime && (t.animationEnd = s.eTime)), this.node.skipRender = !1, window.bccore.GTimeMgr.remFrame(this._checkPlayId), this._checkPlayId = 0;
              }
            }

            set speedRate(t) {
              this.timeScale = t, this._speedRate = t;
            }

            setSpMix(t, e, s) {
              this.setMix(t, e, s);
            }

            changeSkin(e) {
              try {
                e && this.setSkin(e);
              } catch (t) {
                console.error(e + " skin not found");
              }
            }

            setToSetupPose() {
              this.node.skipRender = !0, super.setToSetupPose();
            }

            set maxEndTime(t) {
              t && (this._maxEndTime = t);
            }

            get maxEndTime() {
              return this._maxEndTime;
            }

          };
          i = e([cc._decorator.ccclass("SpineCpn"), s("design:paramtypes", [])], i);
          e = window.bccore.SpineCpn = i;
          t.exports = e;
        },
        312: function (t) {
          var e = this && this.__decorate || function (t, e, s, i) {
            var r,
                a = arguments.length,
                o = a < 3 ? e : null === i ? i = Object.getOwnPropertyDescriptor(e, s) : i;
            if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) o = Reflect.decorate(t, e, s, i);else for (var n = t.length - 1; 0 <= n; n--) (r = t[n]) && (o = (a < 3 ? r(o) : 3 < a ? r(e, s, o) : r(e, s)) || o);
            return 3 < a && o && Object.defineProperty(e, s, o), o;
          };

          let s = class extends cc.Sprite {
            constructor() {
              super(...arguments), this._loadId = 0, this._dynPath = "", this._useFrame = null;
            }

            loadFrame(t, e, s = 0, i) {
              if (this.isValid) {
                var r = t + "/" + (e += "/spriteFrame");

                if (r == this._dynPath) {
                  let t = this._loadedFunc;
                  void (t && t(!0));
                } else {
                  this.clear();
                  t = window.bccore.GAssetMgr.loadAsset(t, e, 2, s, this.recvLoad.bind(this), i);
                  0 < t && (this._dynPath = r, this._loadId = t);
                }
              }
            }

            set useFrame(t) {
              this.isValid && (this.clear(), t && t.addRef(), this.spriteFrame = t, this._useFrame = t);
            }

            set useTexture(e) {
              if (this.clear(), e) {
                let t = new cc.SpriteFrame();
                t.texture = e, this.recvLoad(t), this.spriteFrame = t, this._useFrame = t;
              }
            }

            set loadedFunc(t) {
              this._loadedFunc = t;
            }

            clear() {
              var t = this._loadId;
              0 < t && (window.bccore.GAssetMgr.remLoad(t), this._loadId = 0), this._dynPath = "";
              let e = this._useFrame;
              e && (e.decRef(), this._useFrame = null, this.spriteFrame = null);
            }

            _onPreDestroy() {
              this.clear(), this._loadedFunc = void 0, super._onPreDestroy();
            }

            recvLoad(t) {
              let e = !(this._loadId = 0),
                  s = (t ? (t.addRef(), this.spriteFrame = t, this._useFrame = t) : (this._dynPath = "", e = !1), this._loadedFunc);
              s && s(e);
            }

          };
          s = e([cc._decorator.ccclass("SpriteCpn")], s);
          e = window.bccore.SpriteCpn = s;
          t.exports = e;
        },
        188: (t, e, s) => {
          let d = s(131),
              i = s(174);
          window.bccore.MusicMgr = new class {
            constructor() {
              this._bgRate = 1, this._bgVol = 1, this._talkIdGroup = {}, this._talkPool = [], this._soundVol = 1, this._talkPoolMax = 5, this._muteType = {}, this._onlyId = new i();
            }

            init(t, e) {
              this._fatherNode = t, this._defPro = e, this._defBundle = "exresdir";
            }

            playBg(s, i, r, a) {
              let o = this._fatherNode;

              if (o && s && "" != s) {
                i = i || this._defPro, r = r || this._defBundle;
                let t = this._bgNode,
                    e;
                t ? e = t.getComponent(d) : (t = new cc.Node(), (e = t.addComponent(d)).vol = this._bgVol * this._bgRate, e.isLoop = !0, o.addChild(t), this._bgNode = t);
                var n = s.replace(/\//g, "-");
                n !== t.name && (t.name = n, e.init(r, s, i, a), e.onPlay());
              }
            }

            pauseBg() {
              let e = this._bgNode;

              if (e) {
                let t = e.getComponent(d);
                t.onPause();
              }
            }

            stopBg() {
              let e = this._bgNode;

              if (e) {
                let t = e.getComponent(d);
                t.onStop(), e.name = "";
              }
            }

            resetPlayBg() {
              let e = this._bgNode;

              if (e) {
                let t = e.getComponent(d);
                t.onPlay();
              }
            }

            playTalk(t, e, s, i, r, a = !0) {
              let o = this._fatherNode;
              if (!o || !t || "" == t) return -1;
              s = s || this._defPro, i = i || this._defBundle;

              let n = this._talkPool.pop(),
                  h;

              (h = n ? n.getComponent(d) : (n = new cc.Node()).addComponent(d)).type = e, o.addChild(n);
              var e = this._onlyId.useId,
                  l = (this._talkIdGroup[e] = n, h.loadEndCb = this.talkLoadEnd.bind(this, e, h), n.off(cc.AudioSourceComponent.EventType.ENDED), n.on(cc.AudioSourceComponent.EventType.ENDED, this.talkPlayEnd.bind(this, e), this), this._muteType[h.type]);
              return h.vol = null == l ? this._soundVol : l, h.init(i, t, s, r, this.soundVol, this._muteType), (a || window.bccore.GAssetMgr.getCache(i, t)) && h.onPlay(), e;
            }

            talkPlayEnd(t) {
              var e = this._talkIdGroup[t];
              e && (delete this._talkIdGroup[t], this.recoverTalk(e));
            }

            talkLoadEnd(t, e, s) {
              s || this.talkPlayEnd(t);
            }

            recoverTalk(e) {
              if (e) {
                let t = e.getComponent(d);
                t.clear(), t.reset(), this._talkPool.length < this.talkPoolMax && this._talkPool.push(e), e.removeFromParent(), e.off(cc.AudioSourceComponent.EventType.ENDED);
              }
            }

            stopTalkById(t) {
              this.talkPlayEnd(t);
            }

            stopTalkByType(e) {
              e = e || -1;
              let s = this._talkIdGroup;

              for (var i in s) {
                i = parseInt(i);
                let t = s[i];
                t.getComponent(d).type == e && (delete s[i], this.recoverTalk(t));
              }
            }

            setLoopByTalk(t, e) {
              let s = this._talkIdGroup[t];

              if (s) {
                let t = s.getComponent(d);
                t.isLoop = e;
              }
            }

            stopAllTalk() {
              let t = this._talkIdGroup;

              for (var e in t) {
                var e = parseInt(e),
                    s = t[e];
                delete t[e], this.recoverTalk(s);
              }
            }

            playShort(s, i, r, a, o) {
              let n = this._fatherNode;

              if (n && s && "" != s) {
                i = i || this._defPro, r = r || this._defBundle;
                let t = this._shortNode,
                    e;
                t ? e = t.getComponent(d) : (t = new cc.Node(), (e = t.addComponent(d)).vol = this._soundVol * this._bgRate, e.isLoop = !0, n.addChild(t), this._shortNode = t), e.initShort(r, s, i, a, o);
              }
            }

            playSpShort(s, i, r, a) {
              let o = this._fatherNode;

              if (o && s && "" != s) {
                i = i || this._defPro, r = r || this._defBundle;
                let t = this._spShortNode,
                    e;
                t ? e = t.getComponent(d) : (t = new cc.Node(), (e = t.addComponent(d)).vol = this._soundVol * this._bgRate, o.addChild(t), this._spShortNode = t), e.initSpShort(r, s, i, a);
              }
            }

            set bgVol(e) {
              1 < e ? e = 1 : e < 0 && (e = 0);
              let s = this._bgNode;

              if (s) {
                let t = s.getComponent(d);
                t.vol = e * this._bgRate;
              }

              this._bgVol = e;
            }

            get bgVol() {
              return this._bgVol;
            }

            set bgRate(e) {
              1 < e ? e = 1 : e < 0 && (e = 0);
              let s = this._bgNode;

              if (s) {
                let t = s.getComponent(d);
                t.vol = e * this._bgVol;
              }

              this._bgRate = e;
            }

            set soundVol(s) {
              1 < s ? s = 1 : s < 0 && (s = 0);
              var i,
                  r = this._talkIdGroup;

              for (i in r) {
                let t = r[parseInt(i)],
                    e = t.getComponent(d);
                e.vol = s;
              }

              let e = this._shortNode;

              if (e) {
                let t = e.getComponent(d);
                t.vol = s;
              }

              this._soundVol = s;
            }

            get soundVol() {
              return this._soundVol;
            }

            set talkPoolMax(t) {
              this._talkPoolMax = t;
            }

            get talkPoolMax() {
              return this._talkPoolMax;
            }

            muteByType(s) {
              var i,
                  r = this._talkIdGroup;

              for (i in r) {
                let t = r[parseInt(i)],
                    e = t.getComponent(d);
                e.type == s && (e.vol = 0);
              }

              this._muteType[s] = 0;
            }

            recoByType(s) {
              var i,
                  r = this._talkIdGroup;

              for (i in r) {
                let t = r[parseInt(i)],
                    e = t.getComponent(d);
                e.type == s && (e.vol = this.soundVol);
              }

              this._muteType[s] = this.soundVol;
            }

            release() {}

          }();
        },
        468: (t, e, s) => {
          let i = s(334),
              r = s(312),
              a = s(523),
              o = s(616),
              n = s(47),
              h = s(746);

          window.bccore.newNode = function (e) {
            let s = new i();

            switch (s.layer = cc.Layers.Enum.UI_2D, e) {
              case 0:
                s.addComponent(r);
                break;

              case 1:
                s.addComponent(a);
                break;

              case 3:
                s.addComponent(o);
                break;

              case 4:
                s.addComponent(r), s.addComponent(n);
                break;

              case 5:
                s.addComponent(r), s.addComponent(n);
                let t = new i();
                t.addComponent(o), t.name = "word", s.addChild(t);
                break;

              case 6:
                s.addComponent(h);
            }

            return s;
          };
        },
        334: t => {
          class e extends cc.Node {
            constructor() {
              super(), this._alpha = 255, this._uiCpn = this.addComponent(cc.UITransformComponent);
            }

            set anthorX(t) {
              this._uiCpn.anchorX = t;
            }

            set anthorY(t) {
              this._uiCpn.anchorY = t;
            }

            get anthorX() {
              return this._uiCpn.anchorX;
            }

            get anthorY() {
              return this._uiCpn.anchorY;
            }

            updAnthor(t, e) {
              let s = this._uiCpn;
              s.anchorX = t, s.anchorY = e;
            }

            set scaleX(t) {
              let e = this.scale;
              e.x = t, this.setScale(e);
            }

            set scaleY(t) {
              let e = this.scale;
              e.y = t, this.setScale(e);
            }

            get scaleX() {
              return this.scale.x;
            }

            get scaleY() {
              return this.scale.y;
            }

            set x(t) {
              this.setPosition(t, this.position.y);
            }

            get x() {
              return this.position.x;
            }

            set y(t) {
              this.setPosition(this.position.x, t);
            }

            get y() {
              return this.position.y;
            }

            set width(t) {
              this._uiCpn.width = t;
            }

            get width() {
              return this._uiCpn.width;
            }

            set height(t) {
              this._uiCpn.height = t;
            }

            get height() {
              return this._uiCpn.height;
            }

            set alpha(t) {
              let e = this.getComponent(cc.UIOpacityComponent),
                  s = ((e = e || this.addComponent(cc.UIOpacityComponent)).opacity = t, this._alpha = t, this.getComponent(window.bccore.SpineCpn));
              s && (s.alpha = t);
            }

            get alpha() {
              return this._alpha;
            }

            set renderIdx(t) {
              this._uiCpn.renderIdx = t;
            }

            set dyncBatch2d(t) {
              this._uiCpn.dyncBacth2d = t;
            }

            posWTL(t) {
              return this._uiCpn.convertToNodeSpaceAR(t);
            }

            posLTW(t) {
              return this._uiCpn.convertToWorldSpaceAR(t);
            }

            updSize(t, e) {
              let s = this._uiCpn;
              s.width = t, s.height = e;
            }

            _onPreDestroy() {
              return this._uiCpn = void 0, super._onPreDestroy();
            }

          }

          window.bccore.NodeEx = e, t.exports = e;
        },
        656: () => {},
        469: t => {
          var s, e;
          (e = s = s || {})[e.little = 0] = "little", e[e.big = 1] = "big";

          class i {
            constructor(e, s = 0) {
              this._extSize = 0, this._litEndian = !0, this.EOF_byte = -1, this.EOF_code_point = -1, this._extSize = s = s < 0 ? 0 : s;
              let i,
                  r = 0;

              if (e) {
                let t;
                e instanceof Uint8Array ? (t = e, r = e.length) : (r = e.byteLength, t = new Uint8Array(e)), (i = 0 == s ? new Uint8Array(r) : (e = Math.floor(r / s) + 1, new Uint8Array(e * s))).set(t);
              } else i = new Uint8Array(s);

              this._wpos = r, this._rpos = 0, this._bytes = i, this._data = new DataView(i.buffer);
            }

            set endian(t) {
              let e = !0;
              t == s.big && (e = !1), this._litEndian = e;
            }

            get readAvailable() {
              return this._wpos - this._rpos;
            }

            get buffer() {
              return this._data.buffer.slice(0, this._wpos);
            }

            get rawBuffer() {
              return this._data.buffer;
            }

            set buffer(e) {
              if (e) {
                var s,
                    i = e.byteLength,
                    e = new Uint8Array(e),
                    r = this._extSize;
                let t;
                (t = 0 == r ? new Uint8Array(i) : (s = Math.floor(i / r) + 1, new Uint8Array(s * r))).set(e), this._wpos = i, this._rpos = 0, this._bytes = t, this._data = new DataView(t.buffer);
              }
            }

            set size(t) {
              t <= 0 || (t = new ArrayBuffer(t), this._bytes = new Uint8Array(t), this._data = new DataView(t), this._wpos = 0, this._rpos = 0);
            }

            get bytes() {
              return this._bytes;
            }

            get dataView() {
              return this._data;
            }

            set dataView(t) {
              this.buffer = t.buffer;
            }

            get bufferOffset() {
              return this._data.byteOffset;
            }

            get rpos() {
              return this._rpos;
            }

            set rpos(t) {
              this._rpos = t;
            }

            get length() {
              return this._wpos;
            }

            get bytesAvailable() {
              return this._data.byteLength - this._wpos;
            }

            get bufferLen() {
              return this._data.byteLength;
            }

            delReadBytes() {
              var s = this._rpos;

              if (0 != s) {
                let t = 0,
                    e = this._bytes;
                var i = this._wpos;
                s < i && (e.copyWithin(0, s, i), t = i - s), e.fill(0, t), this._rpos = 0, this._wpos = t;
              }
            }

            clearData() {
              this._bytes.fill(0), this._rpos = 0, this._wpos = 0;
            }

            clear() {
              var t = new ArrayBuffer(this._extSize);
              this._data = new DataView(t), this._bytes = new Uint8Array(t), this._rpos = 0, this._wpos = 0;
            }

            free() {
              this._data = void 0, this._bytes = void 0;
            }

            getBoolean() {
              let t = !1;
              return this.validate(1) && (t = !!this._bytes[this._rpos], this._rpos++), t;
            }

            getByte() {
              let t = 0;
              return this.validate(1) && (t = this._data.getInt8(this._rpos), this._rpos++), t;
            }

            getBytes(t, e = 0, s = 0) {
              if (t) {
                var i = this._rpos,
                    r = this._wpos - i;

                if (!(r <= 0)) {
                  if (0 == s) s = r;else if (r < s) return;
                  t.validateBuffer(s), t._bytes.set(this._bytes.subarray(i, i + s), e), t._wpos += s, this._rpos += s;
                }
              }
            }

            getDouble() {
              let t = 0;
              return this.validate(8) && (t = this._data.getFloat64(this._rpos, this._litEndian), this._rpos += 8), t;
            }

            getFloat() {
              let t = 0;
              return this.validate(4) && (t = this._data.getFloat32(this._rpos, this._litEndian), this._rpos += 4), t;
            }

            getInt() {
              let t = 0;
              return this.validate(4) && (t = this._data.getInt32(this._rpos, this._litEndian), this._rpos += 4), t;
            }

            getShort() {
              let t = 0;
              return this.validate(2) && (t = this._data.getInt16(this._rpos, this._litEndian), this._rpos += 2), t;
            }

            getUByte() {
              let t = 0;
              return this.validate(1) && (t = this._bytes[this._rpos], this._rpos++), t;
            }

            getUInt() {
              let t = 0;
              return this.validate(4) && (t = this._data.getUint32(this._rpos, this._litEndian), this._rpos += 4), t;
            }

            getDeUInt(t) {
              let e = 0;
              return this.validate(4) && (this.decryptGet(t, 4), e = this._data.getUint32(this._rpos, this._litEndian), this.decryptGet(t, 4), this._rpos += 4), e;
            }

            getUShort() {
              let t = 0;
              return this.validate(2) && (t = this._data.getUint16(this._rpos, this._litEndian), this._rpos += 2), t;
            }

            getDeUShort(t) {
              let e = 0;
              return this.validate(2) && (this.decryptGet(t, 2), e = this._data.getUint16(this._rpos, this._litEndian), this.decryptGet(t, 2), this._rpos += 2), e;
            }

            getUTF() {
              var t = this.getUShort();
              return 0 < t ? this.getUTFBytes(t) : "";
            }

            getUTFBytes(t) {
              if (!this.validate(t)) return "";
              var e = this._data,
                  e = new Uint8Array(e.buffer, e.byteOffset + this._rpos, t);
              return this._rpos += t, this.decodeUTF8(e);
            }

            setBoolean(t) {
              this.validateBuffer(1), this._bytes[this._wpos] = +t, this._wpos++;
            }

            setByte(t) {
              this.validateBuffer(1), this._bytes[this._wpos] = 255 & t, this._wpos++;
            }

            setBytes(t, e = 0, s = 0) {
              let i;
              e < 0 || s < 0 || 0 < (i = 0 == s ? t.length - e : Math.min(t.length - e, s)) && (this.validateBuffer(i), 0 == e && i == t.bufferLen ? this._bytes.set(t._bytes, this._wpos) : this._bytes.set(t._bytes.subarray(e, e + i), this._wpos), this._wpos += i);
            }

            setDouble(t) {
              this.validateBuffer(8), this._data.setFloat64(this._wpos, t, this._litEndian), this._wpos += 8;
            }

            setFloat(t) {
              this.validateBuffer(4), this._data.setFloat32(this._wpos, t, this._litEndian), this._wpos += 4;
            }

            setInt(t) {
              this.validateBuffer(4), this._data.setInt32(this._wpos, t, this._litEndian), this._wpos += 4;
            }

            setShort(t) {
              this.validateBuffer(2), this._data.setInt16(this._wpos, t, this._litEndian), this._wpos += 2;
            }

            setUInt(t) {
              this.validateBuffer(4), this._data.setUint32(this._wpos, t, this._litEndian), this._wpos += 4;
            }

            setUShort(t) {
              this.validateBuffer(2), this._data.setUint16(this._wpos, t, this._litEndian), this._wpos += 2;
            }

            setUTF(t) {
              var t = this.encodeUTF8(t),
                  e = t.length;
              this.validateBuffer(2 + e), this._data.setUint16(this._wpos, e, this._litEndian), this._wpos += 2, this.setUint8Array(t, !1);
            }

            setUTFBytes(t) {
              this.setUint8Array(this.encodeUTF8(t));
            }

            setUint8Array(t, e = !0) {
              var s;
              !t || 0 != (s = t.length) && (e && this.validateBuffer(s), this._bytes.set(t, this._wpos), this._wpos += s);
            }

            validate(t) {
              var e = this._wpos;
              return 0 < e && this._rpos + t <= e;
            }

            validateBuffer(e) {
              e = this._wpos + e;

              if (this._data.byteLength < e) {
                var s = this._extSize;
                let t;
                (t = 0 == s ? new Uint8Array(e) : (e = Math.floor(e / s) + 1, new Uint8Array(e * s))).set(this._bytes), this._bytes = t, this._data = new DataView(t.buffer);
              }
            }

            encodeUTF8(t) {
              let e = 0;
              var s = this.stringToCodePoints(t);
              let i = [];

              for (; s.length > e;) {
                var r = s[e++];
                if (!this.inRange(r, 55296, 57343)) if (this.inRange(r, 0, 127)) i.push(r);else {
                  let t, e;

                  for (this.inRange(r, 128, 2047) ? (t = 1, e = 192) : this.inRange(r, 2048, 65535) ? (t = 2, e = 224) : this.inRange(r, 65536, 1114111) && (t = 3, e = 240), i.push(this.div(r, Math.pow(64, t)) + e); 0 < t;) {
                    var a = this.div(r, Math.pow(64, t - 1));
                    i.push(128 + a % 64), --t;
                  }
                }
              }

              return new Uint8Array(i);
            }

            decodeUTF8(t) {
              let e = 0,
                  s = "",
                  i,
                  r = 0,
                  a = 0,
                  o = 0,
                  n = 0;

              for (; t.length > e;) {
                var h,
                    l,
                    d = t[e++];
                null !== (i = d == this.EOF_byte ? 0 != a ? 65533 : this.EOF_code_point : 0 == a ? this.inRange(d, 0, 127) ? d : (this.inRange(d, 194, 223) ? (a = 1, n = 128, r = d - 192) : this.inRange(d, 224, 239) ? (a = 2, n = 2048, r = d - 224) : this.inRange(d, 240, 244) && (a = 3, n = 65536, r = d - 240), r *= Math.pow(64, a), null) : this.inRange(d, 128, 191) ? (o += 1, r += (d - 128) * Math.pow(64, a - o), o !== a ? null : (h = r, l = n, r = 0, a = 0, o = 0, n = 0, this.inRange(h, l, 1114111) && !this.inRange(h, 55296, 57343) ? h : d)) : (r = 0, a = 0, o = 0, n = 0, e--, d)) && i !== this.EOF_code_point && (i <= 65535 ? 0 < i && (s += String.fromCharCode(i)) : (i -= 65536, s = (s += String.fromCharCode(55296 + (i >> 10 & 1023))) + String.fromCharCode(56320 + (1023 & i))));
              }

              return s;
            }

            inRange(t, e, s) {
              return e <= t && t <= s;
            }

            div(t, e) {
              return Math.floor(t / e);
            }

            stringToCodePoints(t) {
              let e = [],
                  s = 0,
                  i = t.length;

              for (; s < t.length;) {
                var r,
                    a = t.charCodeAt(s);
                this.inRange(a, 55296, 57343) ? this.inRange(a, 56320, 57343) || s == i - 1 ? e.push(65533) : (r = t.charCodeAt(s + 1), this.inRange(r, 56320, 57343) ? (s += 1, e.push(65536 + ((1023 & a) << 10) + (1023 & r))) : e.push(65533)) : e.push(a), s += 1;
              }

              return e;
            }

            encodeOfByte(t, e = 0, i = 0) {
              let r = this._data;
              var a = this._wpos;

              if (r && 0 < a) {
                var o = 255 & t;
                if (e <= 0 && i <= 0) for (let t = 0; t < a; t++) {
                  var s = r.getUint8(t);
                  s ^= o, r.setUint8(t, s);
                } else {
                  let s = 0;

                  if (0 < e) {
                    a < (s = e) && (s = a);

                    for (let t = 0; t < s; t++) {
                      var n = r.getUint8(t);
                      n ^= o, r.setUint8(t, n);
                    }
                  }

                  if (0 < i) {
                    let e = a - s;
                    if (0 < e) for (let t = a - (e = e > i ? i : e); t < a; t++) {
                      var h = r.getUint8(t);
                      h ^= o, r.setUint8(t, h);
                    }
                  }
                }
              }
            }

            getUTF8ByKey(t) {
              let e = "";
              var s = 255 & t,
                  t = t >> 8,
                  i = (t &= 255, this.getUByte()),
                  r = (i ^= s, this.getUByte()),
                  a = (r = (r ^ s) << 8, this.getUByte()),
                  o = (a = (a ^ s) << 16, this.getUByte()),
                  i = i + r + a + (o = (o ^ s) << 24);
              return 0 < i && this.validate(i) && (r = this._rpos, o = this._bytes.slice(r, a = r + i), this._rpos = a, e = this.decodeUTF8ByKey(o, [s, t])), e;
            }

            decodeUTF8ByKey(t, e) {
              if (!e || 0 == e.length) return "";
              let s = 0,
                  i = "",
                  r,
                  a = 0,
                  o = 0,
                  n = 0,
                  h = 0;

              for (var l = e.length; t.length > s;) {
                var d,
                    c = e[s % l],
                    _ = t[s++];
                -1 == (_ ^= c) ? 0 == o && (r = -1) : r = 0 == o ? this.inRange(_, 0, 127) ? _ : (this.inRange(_, 194, 223) ? (o = 1, h = 128, a = _ - 192) : this.inRange(_, 224, 239) ? (o = 2, h = 2048, a = _ - 224) : this.inRange(_, 240, 244) ? (o = 3, h = 65536, a = _ - 240) : this.decoderError(!1), a *= Math.pow(64, o), null) : this.inRange(_, 128, 191) ? (n += 1, a += (_ - 128) * Math.pow(64, o - n), n !== o ? null : (c = a, d = h, a = 0, o = 0, n = 0, h = 0, this.inRange(c, d, 1114111) && !this.inRange(c, 55296, 57343) ? c : this.decoderError(!1, _))) : (a = 0, o = 0, n = 0, h = 0, s--, this.decoderError(!1, _)), null !== r && -1 !== r && (r <= 65535 ? 0 < r && (i += String.fromCharCode(r)) : (r -= 65536, i = (i += String.fromCharCode(55296 + (r >> 10 & 1023))) + String.fromCharCode(56320 + (1023 & r))));
              }

              return i;
            }

            decoderError(t, e) {
              return e || 65533;
            }

            decryptGet(e, t) {
              var s = this._rpos,
                  i = s + t;
              let r = this._data;
              e &= 255;

              for (let t = s; t < i; t++) {
                var a = r.getUint8(t);
                a ^= e, r.setUint8(t, a);
              }
            }

          }

          bccore.Bytes = i, t.exports = i;
        },
        482: () => {
          window.bccore.exeError = function (t) {
            console.error(t);
          };
        },
        174: t => {
          class e {
            constructor() {
              this._useId = 1, this._initId = 1;
            }

            set defInitId(t) {
              this._initId = t;
            }

            get useId() {
              var t = this._useId;
              return this._useId++, t;
            }

            resetId() {
              this._useId = this._initId;
            }

          }

          window.bccore.OnlyId = e, t.exports = e;
        },
        267: t => {
          t.exports = class e {
            constructor(t, e) {
              this._x = t, this._y = e;
            }

            set x(t) {
              this._x = t;
            }

            get x() {
              return this._x;
            }

            set y(t) {
              this._y = t;
            }

            get y() {
              return this._y;
            }

            clone() {
              return new e(this._x, this._y);
            }

          };
        },
        275: () => {
          function m(t, e) {
            return e.tKey - t.tKey;
          }

          function y(t, e) {
            let s = e.pri - t.pri;
            return s = 0 == s ? e.tKey - t.tKey : s;
          }

          window.bccore.GTimeMgr = new class {
            constructor() {
              this.id = "bctime", this._keyCache = 1, this._rates = {}, this._newTimeInfos = {}, this._runTimeInfos = [], this._newFrameInfos = {}, this._runFrameInfos = [], cc.Director.instance.getScheduler().scheduleUpdate(this, 999999, !1);
            }

            update(t) {
              var e,
                  s,
                  a = Math.floor(1e3 * t);
              let i = this._runFrameInfos;

              for (let s = i.length - 1; 0 <= s; s--) {
                let e = i[s];

                if (e) {
                  let t = e.exeCb;

                  if (t) {
                    var r = e.dTime;

                    if (0 < r) {
                      let t = this._rates[e.rateTp];

                      if (0 < (r -= (t = void 0 === t ? 1 : t) * a)) {
                        e.dTime = r;
                        continue;
                      }

                      e.dTime = 0;
                    }

                    r = e.count;
                    0 < r && (0 < --r ? e.count = r : (e.exeCb = void 0, i.splice(s, 1)));

                    try {
                      t(e.tKey);
                    } catch (t) {
                      globalThis.errLog(t, "frame time");
                    }
                  } else i.splice(s, 1);
                }
              }

              let o = 0,
                  n = this._newFrameInfos;

              for (e in n) {
                var h = parseInt(e),
                    l = n[h];
                delete n[h], i.push(l), o++;
              }

              0 < o && i.sort(y);
              let d = this._runTimeInfos;

              for (let r = d.length - 1; 0 <= r; r--) {
                let i = d[r];

                if (i) {
                  let s = i.exeCb;

                  if (s) {
                    let t = this._rates[i.rateTp],
                        e = (t = void 0 === t ? 1 : t) * a;
                    var c = i.dTime;

                    if (0 < c) {
                      if ((e -= c) < 0) {
                        i.dTime = Math.abs(e);
                        continue;
                      }

                      i.dTime = 0;
                    }

                    if (0 < i.tTime) {
                      let t = i.split + e;
                      c = i.tTime;

                      if (t < c) {
                        i.split = t;
                        continue;
                      }

                      t -= c, i.split = t;
                    }

                    c = i.count - 1;
                    0 == c ? (i.exeCb = void 0, d.splice(r, 1)) : 0 < c && (i.count = c);

                    try {
                      s(i.tKey);
                    } catch (t) {
                      globalThis.errLog(t, "normal time");
                    }
                  } else d.splice(r, 1);
                }
              }

              let _ = 0,
                  p = this._newTimeInfos;

              for (s in p) {
                var u = parseInt(s),
                    f = p[u];
                delete p[u], d.push(f), _++;
              }

              0 < _ && d.sort(m);
            }

            setRateByType(t, e) {
              this._rates[t] = e;
            }

            delRateByType(t) {
              delete this._rates[t];
            }

            exeTime(t, e, s, i = 0, r = -1) {
              if (!t || 0 === s) return 0;
              var a = this._keyCache++,
                  i = {
                tKey: a,
                dTime: i = i < 0 ? 0 : i,
                split: 0,
                tTime: e = e < 0 ? 0 : e,
                count: s,
                rateTp: r,
                exeCb: t
              };
              return this._newTimeInfos[a] = i, a;
            }

            remTime(i) {
              if (0 != i) {
                let t = this._newTimeInfos[i];
                if (void 0 !== t) return t.exeCb = void 0, void delete this._newTimeInfos[i];
                let s = this._runTimeInfos;

                for (let e = 0; e < s.length; e++) {
                  let t = s[e];

                  if (i == t.tKey) {
                    t.exeCb = void 0, s.splice(e, 1);
                    break;
                  }
                }
              }
            }

            exeFrame(t, e = 0, s = 0, i = 0, r = -1) {
              if (!t) return 0;
              var a = this._keyCache++,
                  s = {
                tKey: a,
                count: s,
                dTime: i = i < 0 ? 0 : i,
                pri: e,
                rateTp: r,
                exeCb: t
              };
              return this._newFrameInfos[a] = s, a;
            }

            remFrame(i) {
              if (0 != i) {
                let t = this._newFrameInfos[i];
                if (void 0 !== t) return t.exeCb = void 0, void delete this._newFrameInfos[i];
                let s = this._runFrameInfos;

                for (let e = 0; e < s.length; e++) {
                  let t = s[e];

                  if (i == t.tKey) {
                    t.exeCb = void 0, s.splice(e, 1);
                    break;
                  }
                }
              }
            }

          }();
        },
        342: (t, e, s) => {
          "use strict";

          Object.defineProperty(e, "__esModule", {
            value: !0
          }), e.HttpE = void 0;
          let l = s(964),
              i = s(174);
          var d;
          (s = d = e.HttpE || (e.HttpE = {})).get = "GET", s.post = "POST";

          class r {
            constructor() {
              this._httpDic = {}, this._onlyId = new i();
            }

            static get ins() {
              return this._ins || (this._ins = new r()), this._ins;
            }

            sendGet(e, s, i, r, a) {
              if (e && s) {
                let t = new l(e, d.get, this);
                e = this._onlyId.useId;
                if (t.id = e, t.httpcb = s, t.errMax = r, t.timeOut = a, t.ctrlCall = this.delHttpDic.bind(this), this._httpDic[e] = t, i) for (var o in i) t.setHeader(o, i[o]);
                return t.startSend(), e;
              }
            }

            sendPost(t, e, s, i, r, a, o) {
              let n = new l(t, d.post, this);
              var h,
                  t = this._onlyId.useId;

              for (h in n.id = t, n.httpcb = s, n.errMax = r, n.timeOut = a, n.ctrlCall = this.delHttpDic.bind(this), this._httpDic[t] = n, i = i || {
                "Content-Type": "application/json;charset=utf-8"
              }) n.setHeader(h, i[h]);

              return o || (e = JSON.stringify(e)), n.startSend(e), t;
            }

            delHttpDic(t) {
              this._httpDic[t] && delete this._httpDic[t];
            }

            stopById(t) {
              let e = this._httpDic[t];
              e && (e.release(), delete this._httpDic[t]);
            }

          }

          window.bccore.HttpControl = r.ins, t.exports = r;
        },
        964: (t, e, s) => {
          s(174);
          t.exports = class {
            constructor(t, e) {
              this._httpReq = null, this._httpDic = {}, this._timeOut = 1e4, this._errMax = 3, this._errIdx = 0, this._params = null, this._ctrlCall = null, this._reqUrl = "", this._reqMet = "", this.create(t, e);
            }

            create(t, e) {
              if (this._reqUrl = t, this._reqMet = e, this.stop(), t) {
                let t = new XMLHttpRequest();
                t.onload = this.httpCall.bind(this, 0), t.onabort = this.httpCall.bind(this, 1), t.onerror = this.httpCall.bind(this, 2), t.ontimeout = this.httpCall.bind(this, 3), this._httpReq = t, this.openMet();
              }
            }

            openMet() {
              this._httpReq.open(this._reqMet, this._reqUrl);
            }

            set httpcb(t) {
              this._httpcb = t;
            }

            set ctrlCall(t) {
              this._ctrlCall = t;
            }

            set id(t) {
              this._id = t;
            }

            set errMax(t) {
              t && t > this._errMax && (this._errMax = t);
            }

            set timeOut(t) {
              t && t > this._timeOut && (this._timeOut = t);
            }

            setHeader(t, e) {
              this._httpDic[t] = e;
            }

            httpCall(t) {
              0 == t && this._httpReq.status < 400 ? this.httpResp(!0) : 1 == t ? this.release() : this._errIdx >= this._errMax ? this.httpResp(!1) : (this.openMet(), this._errIdx++, this.startSend(this._params));
            }

            httpResp(t) {
              var e,
                  s = this._httpReq;
              s && (e = s.response, s = s.status, this._httpcb && this._httpcb(t, e, s), this.release());
            }

            startSend(t) {
              let e = this._httpReq;

              if (e) {
                e.timeout = this._timeOut;
                var s,
                    i = this._httpDic;

                for (s in i) e.setRequestHeader(s, i[s]);

                e.send(t), this._params = t;
              }
            }

            stop() {
              let t = this._httpReq;
              var e;
              t && (e = null, t.onload = e, t.onabort = e, t.onerror = e, t.ontimeout = e, t.abort(), this._httpReq = e), this._errIdx = 0;
            }

            release() {
              this.stop();
              let t = this._httpDic;

              for (var e in t) delete t[e];

              this._httpDic = {}, this._httpcb = null, this._ctrlCall && this._id && this._ctrlCall(this._id), this._ctrlCall = null, this._id = null;
            }

          };
        },
        304: (t, e, s) => {
          let i = s(469),
              p = window.bccore;
          p.NetControl = class {
            constructor() {
              this._ip = "", this._pt = 0, this._wss = !1, this._tickKey = 0, this._closeTickKey = 0, this._recvStream = new i(void 0, 512), this._unpackStream = new i(), this._packStream = new i(), this._sendStream = new i(), this._respondCbs = {}, this._useIdx = -2, this._useKey = 188, this._timeMgr = p.GTimeMgr;
            }

            free() {
              this.resetSocket(), this._useSock && (this._useSock.close(), this._useSock = void 0);
              var t = this._tickKey,
                  t = (t && (this._timeMgr.remFrame(t), this._tickKey = 0), this._closeTickKey),
                  t = (t && (this._timeMgr.remFrame(t), this._closeTickKey = 0), this._recvStream.free(), this._unpackStream.free(), this._sendStream.free(), this._packStream.free(), this.unregAllFunc(), void 0);
              this._ptData = t, this._closeTaskCb = t, this._connectTaskCb = t, this._recvStream = t, this._unpackStream = t, this._sendStream = t, this._packStream = t, this._respondCbs = t, this._timeMgr = t;
            }

            setIpPort(t, e) {
              this._ip = t, this._pt = e;
            }

            set wss(t) {
              this._wss = t;
            }

            set ptData(t) {
              this._ptData = t;
            }

            set connectTaskCb(t) {
              this._connectTaskCb = t;
            }

            set closeTaskCb(t) {
              this._closeTaskCb = t;
            }

            setParams(t, e) {
              this._useIdx = t, this._useKey = e;
            }

            regFunc(t, e) {
              e && (this._respondCbs[t] = e);
            }

            get isConnected() {
              let t = !1;
              var e = this._useSock;
              return t = e && 1 == e.readyState ? !0 : t;
            }

            get isShutDown() {
              let t = !1;
              var e = this._useSock;
              return t = e && 3 == e.readyState ? !0 : t;
            }

            unregFunc(t) {
              this._respondCbs[t] && delete this._respondCbs[t];
            }

            unregAllFunc() {
              let t = this._respondCbs;

              for (var e in t) {
                e = parseInt(e);
                delete t[e];
              }
            }

            connectServer() {
              this.resetSocket();
              let t = !1;
              var e = this._closeTickKey,
                  e = (e && (this._timeMgr.remFrame(e), this._closeTickKey = 0, t = !0), this._useSock && (this._useSock.close(), t = !0), t && (this._recvStream.clearData(), this._unpackStream.clearData(), this._sendStream.clearData(), this._packStream.clearData()), this._wss ? "wss://" : "ws://");
              let s = "";
              var i = Boolean(this._pt);
              s = i ? e + this._ip + ":" + this._pt : e + this._ip;
              let r = new WebSocket(s);
              r.binaryType = "arraybuffer", r.onopen = this.recvOpend.bind(this), r.onclose = this.recvClosed.bind(this, !0), r.onerror = this.recvClosed.bind(this, !0), r.onmessage = this.recvMsg.bind(this), this._useSock = r, this._useKey = 188;
            }

            closeServer() {
              let t = this._useSock;
              t && (3 == t.readyState ? (this.resetSocket(), this._useSock = void 0, 0 == this._closeTickKey && (this._closeTickKey = this._timeMgr.exeFrame(this.recvClosed.bind(this), -200, 1))) : t.close());
            }

            sendData(i, r = null) {
              if (this.isConnected) {
                let s = this._useIdx;

                if (-2 != s) {
                  let t;
                  var a = this._ptData,
                      a = (a && (t = a.send), i.toString());

                  if (t && t[a]) {
                    globalThis.printPro && console.log(`send proto ${i}:-->`, r);
                    a = t[a];
                    let e = this._packStream;

                    if (this.compress(a, r, e)) {
                      a = e.length + 3;
                      let t = this._sendStream;
                      t.size = a + 4, t.setUInt(a), t.setUShort(i), t.setByte(s), t.setBytes(e), t.encodeOfByte(this._useKey, 32, 32), this._useSock.send(t.bytes.buffer), t.clear(), 127 <= s ? s = 0 : s++, this._useIdx = s;
                    }

                    e.clearData();
                  }
                }
              }
            }

            resetSocket() {
              let t = this._useSock;
              t && (t.onopen = null, t.onclose = null, t.onerror = null, t.onmessage = null);
            }

            recvOpend(t) {
              0 == this._tickKey && (this._tickKey = this._timeMgr.exeFrame(this.checkMessage.bind(this), -999));
              let e = this._connectTaskCb;
              e && e();
            }

            recvClosed(t, e) {
              t ? (this.resetSocket(), this._useSock = void 0) : this._closeTickKey = 0, this._recvStream.clearData(), this._unpackStream.clearData(), this._sendStream.clearData(), this._packStream.clearData();
              t = this._tickKey;
              t && (this._timeMgr.remFrame(t), this._tickKey = 0);
              let s = this._closeTaskCb;
              s && s(), this._useKey = 188;
            }

            recvMsg(t) {
              t = t.data;

              this._recvStream.setUint8Array(new Uint8Array(t));
            }

            checkMessage() {
              let a = this._recvStream;
              if (a.length < 6) return !1;
              var o = this._useKey;
              let n = a.getDeUInt(o);
              if (n > a.length - a.rpos) a.rpos = 0;else {
                let t = a.getDeUShort(o);
                (n -= 2) < 0 && (n = 0);
                let e;
                var h = this._ptData,
                    h = (h && (e = h.recv), t.toString());
                let s = this._respondCbs[t];
                if (!e || !e[h] || !s) return a.rpos += n, a.delReadBytes(), void globalThis.prinf("the proto is not listening =>", t);
                let i = this._unpackStream;
                0 < n && (a.getBytes(i, 0, n), i.encodeOfByte(o, 26, 32));
                o = e[h], h = this.decompress(o, i);
                let r = !1;
                if (i.rpos <= i.length && (r = !0), a.delReadBytes(), i.clearData(), r) try {
                  s(h);
                } catch (t) {
                  globalThis.errLog(t, "netcontrol");
                }
              }
            }

            decompress(e, s) {
              if (0 == e.length) return null;
              let i = {};
              let r;

              for (let t = 0; t < e.length; t++) {
                if (s.rpos == s.length) {
                  i = null;
                  break;
                }

                var a = e[t],
                    o = a.type,
                    n = a.name;

                if ("byte" == o) {
                  var h = s.getInt();
                  r = 0 == h ? null : (l = new Bytes(), s.getBytes(l, 0, h), l);
                } else if ("int8" == o) r = s.getByte();else if ("uint8" == o) r = s.getUByte();else if ("int16" == o) r = s.getShort();else if ("uint16" == o) r = s.getUShort();else if ("int32" == o) r = s.getInt();else if ("uint32" == o) r = s.getUInt();else if ("int64" == o) {
                  var h = s.getUInt(),
                      l = s.getInt();
                  r = p.set64TStr({
                    low32: h,
                    high32: l
                  });
                } else if ("string" == o) r = s.getUTF();else if ("array" == o) {
                  let e = [];
                  var d = s.getShort();

                  if (0 < d) {
                    var c,
                        _ = a.fields;

                    for (let t = 0; t < d; t++) {
                      if (null == (c = this.decompress(_, s))) {
                        i = null;
                        break;
                      }

                      e[t] = c;
                    }
                  }

                  r = e;
                }

                i && (i[n] = r);
              }

              return i;
            }

            compress(e, s, i) {
              if (0 == e.length) return !0;
              if (null == s) return !1;
              var r;

              for (let t = 0; t < e.length; t++) {
                var a,
                    o = e[t];
                if (null == (a = s[o.name])) return !1;
                if ("byte" == (r = o.type)) i.setBytes(a);else if ("int8" == r) i.setByte(a);else if ("uint8" == r) i.setByte(a);else if ("int16" == r) i.setShort(a);else if ("uint16" == r) i.setUShort(a);else if ("int32" == r) i.setInt(a);else if ("uint32" == r) i.setUInt(a);else if ("int64" == r) {
                  var n = p.getStrT64(a);
                  i.setUInt(n.low32), i.setInt(n.high32);
                } else if ("string" == r) i.setUTF(a);else if ("array" == r) {
                  if (!Array.isArray(a)) return !1;
                  if (0 == a.length) i.setUShort(0);else {
                    i.setShort(a.length);
                    var h = o.fields;

                    for (let t = 0; t < a.length; t++) {
                      var l = a[t];
                      if (!this.compress(h, l, i)) return !1;
                    }
                  }
                }
              }

              return !0;
            }

          };
        },
        594: () => {
          let i = window.bccore;

          function r(t) {
            let e = 0;
            return e = t ? t.high32 * Math.pow(2, 32) + t.low32 : e;
          }

          function a(t) {
            let e = r(t);
            return e.toString();
          }

          function s(t) {
            return t.high32.toString() + "~" + t.low32.toString();
          }

          function o(t) {
            t = t.split("~");
            let e = {};
            return 2 == t.length && (e.high32 = parseInt(t[0]), e.low32 = parseInt(t[1])), e;
          }

          function n(t) {
            let e = {
              low32: 0,
              high32: 0
            };
            var s, i;
            return 0 != t && (s = Math.pow(2, 32), i = Math.floor(t / s), e.high32 = i, e.low32 = t - i * s), e;
          }

          i.dataToInt64 = r, i.dataToInt64Str = a, i.set64TStr = s, i.getStrT64 = o, i.int64TStr = function (t) {
            let e = t.toString();
            var s = e.split("~");
            return e = 2 == s.length ? a(o(t)) : e;
          }, i.int64TNum = function (t) {
            let e = t.toString();
            var s = e.split("~");
            return e = 2 == s.length ? r(o(t)) : Number(t);
          }, i.int64ToData = n, i.int2Int64 = function (t) {
            let e = 0;
            return s(n(e = t ? parseInt(t) : e));
          }, i.int64StrToData = function (t) {
            return n(parseInt(t));
          }, i.catchErr = function (t, e = "") {
            let s = "beichen error = " + e;
            t && (t.stack ? s += ">>>stackInfo = " + t.stack : t.message && (s += ">>>message = " + t.message)), i.exeError(s);
          }, i.randomN = function (t) {
            return t = Math.random() * t, Math.round(t);
          };
        }
      },
          i = {};

      function r(t) {
        var e = i[t];
        if (void 0 !== e) return e.exports;
        e = i[t] = {
          exports: {}
        };
        return s[t].call(e.exports, e, e.exports, r), e.exports;
      }

      window.bccore = {}, r(656), r(482), r(174), r(267), r(469), r(275), r(594), r(342), r(304), r(746), r(523), r(312), r(616), r(131), r(47), r(334), r(468), r(671), r(188);
    })();
  }).call(root);
})( // The environment-specific global.
function () {
  if (typeof globalThis !== 'undefined') return globalThis;
  if (typeof self !== 'undefined') return self;
  if (typeof window !== 'undefined') return window;
  if (typeof global !== 'undefined') return global;
  if (typeof this !== 'undefined') return this;
  return {};
}.call(this));